
#import "BoardWindow.h"
#import <appkit/Application.h>
#import <appkit/View.h>
#import <appkit/nextstd.h>
#import <dpsclient/psops.h>

@interface AbstractSquare : View {
    short  row, column;
    BOOL   isHighlighted;
    int    trackingRectNumber;
}

- (short) column;
- (short) distanceTo: otherSquare;
- drawSelf: (const NXRect *) rects : (int) rectCount;
- (BOOL) isHighlighted;
- mouseExited: (NXEvent *) theEvent;
- (short) row;
- setIsHighlighted: (BOOL) state;

/* Private methods: */

- awake;
- appDidInit;
- appDidInitInside: (BOOL) state;
- become: newSquareClass;
- capture: sender;
- checkAdjacencyWith: sender;
- free;
- freeTrackingRect;
- highlight: (const NXRect *) aRect;
- initFrame: (const NXRect *) frameRect;
- setTrackingRect: (const NXRect *) aRect inside: (BOOL) state;

@end
