/*
                GNU GO - the game of Go (Wei-Chi)
                Version 1.1   last revised 3-1-89
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
                    documented by Bob Webber
                    NeXT version by John Neil
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 1.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

mail address:   Man L. Li
                Dept. of Computer Science
                University of Houston
                4800 Calhoun Road
                Houston, TX 77004

e-mail address: manli@cs.uh.edu         (Internet)
                coscgbn@uhvax1.bitnet   (BITNET)
                70070,404               (CompuServe)

For the NeXT version, please report any bug/fix, modification, suggestion to

mail address:   John Neil
                Mathematics Department
                Portland State University
                PO Box 751
                Portland, OR  97207

e-mail address: neil@math.mth.pdx.edu  (Internet)
                neil@psuorvm.bitnet    (BITNET)
*/

#import <appkit/View.h>
#import <dpsclient/dpsNeXT.h>

// Maximum number of tiles in the playing area...
  
#define WHITESTONE	1     
#define BLACKSTONE	2
  
extern unsigned char p[19][19];
extern unsigned char patternmat[19][19], scoringmat[19][19], ownermat[19][19];
extern unsigned char tempmat[19][19], newpatternmat[19][19], mark[19][19];
extern int rd, bothSides, neitherSide, blackSide, whiteSide, MAXX, MAXY;
extern int opn[9], blackCaptured, whiteCaptured, handicap;
extern int currentStone, opposingStone, blackPassed, whitePassed;
extern int blackTerritory, whiteTerritory;
extern float black_Score, white_Score;

@interface GoView:View 
{
  
  BOOL gameRunning, finished;
  
  id blackStone, whiteStone, grayStone, backGround, gameMessage, blackPrisoners, whitePrisoners, gameMessage2, startButton, stopButton, passButton, mainMenu, upperLeft, upperRight, lowerLeft, lowerRight, midLeft, midRight, midTop, midBottom, innerSquare, innerHandicap;
  
  // The following six are outlets set when the nib file is being
    // read in.
      
    }

// The following methods can be called by Interface Builder objects &
  // during creation/destruction of instances of BreakView.
  
  - initFrame:(const NXRect *)frm;
- free;

- startNewGame;
- go:sender;              // mouseDown: on the view does the same thing
  - stop:sender;
  - passMove;

- changeBackground:sender;
- revertBackground:sender;

// The following methods are internal and probably should not be called
  // by others.
  
  - setBackgroundFile:(const char *)fileName andRemember:(BOOL)remember;
- drawSelf:(NXRect *)rects :(int)rectCount;
- drawBackground:(NXRect *)rect;
- showBlackStone;
- showWhiteStone;
- showBackgroundPiece: (int)x: (int)y;
- eraseStone;
- updateInfo;
- scoreGame;
- step;
- selectMove;
- selectMoveEnd;
- flashStone: (int)x :(int)y;

@end
